-- TESTBENCH for SRP

-- Bubble sort

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

use WORK.ALU_PKG.all;

entity TEST_SRP is
end entity TEST_SRP;

architecture TESTBENCH of TEST_SRP is
-- SRP
component SRP is
port(Clock   : in  std_logic;
     Reset_b : in  std_logic;
	  gout0   : out std_logic;
     gout1   : out std_logic;
     gout2   : out std_logic;
     gout3   : out std_logic;
     gout4   : out std_logic );	  
end component;

-- system clock
    signal  Clock  : std_logic := '0';
-- system reset
    signal  Reset_b: std_logic := '0';
-- wires on the board
    signal  gout0  : std_logic;
	 signal  gout1  : std_logic;
	 signal  gout2  : std_logic;
	 signal  gout3  : std_logic;
	 signal  gout4  : std_logic;

    
begin
  -- clock generator while Iadd is less than 24.
    CLOCK_GEN: process 
    begin
	     wait for 5 ns;
	     Clock <= not Clock;
    end process CLOCK_GEN;

  -- SRP
    SRP00: SRP port map (Clock,Reset_b,gout0,gout1,gout2,gout3,gout4);
	 
  -- reset sequence
    RESET_SEQ: process
    begin
        wait for 100 ns;
	Reset_b <= '1';
    end process RESET_SEQ;
	 
end architecture TESTBENCH;